<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMobileStatusLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfMobileStatusLog extends AbstractStructArrayBase
{
    /**
     * The MobileStatusLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MobileStatusLog[]
     */
    public $MobileStatusLog;
    /**
     * Constructor method for ArrayOfMobileStatusLog
     * @uses ArrayOfMobileStatusLog::setMobileStatusLog()
     * @param \StructType\MobileStatusLog[] $mobileStatusLog
     */
    public function __construct(array $mobileStatusLog = array())
    {
        $this
            ->setMobileStatusLog($mobileStatusLog);
    }
    /**
     * Get MobileStatusLog value
     * @return \StructType\MobileStatusLog[]|null
     */
    public function getMobileStatusLog()
    {
        return $this->MobileStatusLog;
    }
    /**
     * This method is responsible for validating the values passed to the setMobileStatusLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMobileStatusLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMobileStatusLogForArrayConstraintsFromSetMobileStatusLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMobileStatusLogMobileStatusLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfMobileStatusLogMobileStatusLogItem instanceof \StructType\MobileStatusLog) {
                $invalidValues[] = is_object($arrayOfMobileStatusLogMobileStatusLogItem) ? get_class($arrayOfMobileStatusLogMobileStatusLogItem) : sprintf('%s(%s)', gettype($arrayOfMobileStatusLogMobileStatusLogItem), var_export($arrayOfMobileStatusLogMobileStatusLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MobileStatusLog property can only contain items of type \StructType\MobileStatusLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MobileStatusLog value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileStatusLog[] $mobileStatusLog
     * @return \ArrayType\ArrayOfMobileStatusLog
     */
    public function setMobileStatusLog(array $mobileStatusLog = array())
    {
        // validation for constraint: array
        if ('' !== ($mobileStatusLogArrayErrorMessage = self::validateMobileStatusLogForArrayConstraintsFromSetMobileStatusLog($mobileStatusLog))) {
            throw new \InvalidArgumentException($mobileStatusLogArrayErrorMessage, __LINE__);
        }
        $this->MobileStatusLog = $mobileStatusLog;
        return $this;
    }
    /**
     * Add item to MobileStatusLog value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileStatusLog $item
     * @return \ArrayType\ArrayOfMobileStatusLog
     */
    public function addToMobileStatusLog(\StructType\MobileStatusLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MobileStatusLog) {
            throw new \InvalidArgumentException(sprintf('The MobileStatusLog property can only contain items of type \StructType\MobileStatusLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MobileStatusLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MobileStatusLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MobileStatusLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MobileStatusLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MobileStatusLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MobileStatusLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MobileStatusLog
     */
    public function getAttributeName()
    {
        return 'MobileStatusLog';
    }
}
