<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripsAndPcounter ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripsAndPcounter extends AbstractStructArrayBase
{
    /**
     * The TripsAndPcounter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TripsAndPcounter[]
     */
    public $TripsAndPcounter;
    /**
     * Constructor method for ArrayOfTripsAndPcounter
     * @uses ArrayOfTripsAndPcounter::setTripsAndPcounter()
     * @param \StructType\TripsAndPcounter[] $tripsAndPcounter
     */
    public function __construct(array $tripsAndPcounter = array())
    {
        $this
            ->setTripsAndPcounter($tripsAndPcounter);
    }
    /**
     * Get TripsAndPcounter value
     * @return \StructType\TripsAndPcounter[]|null
     */
    public function getTripsAndPcounter()
    {
        return $this->TripsAndPcounter;
    }
    /**
     * This method is responsible for validating the values passed to the setTripsAndPcounter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripsAndPcounter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripsAndPcounterForArrayConstraintsFromSetTripsAndPcounter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripsAndPcounterTripsAndPcounterItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripsAndPcounterTripsAndPcounterItem instanceof \StructType\TripsAndPcounter) {
                $invalidValues[] = is_object($arrayOfTripsAndPcounterTripsAndPcounterItem) ? get_class($arrayOfTripsAndPcounterTripsAndPcounterItem) : sprintf('%s(%s)', gettype($arrayOfTripsAndPcounterTripsAndPcounterItem), var_export($arrayOfTripsAndPcounterTripsAndPcounterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripsAndPcounter property can only contain items of type \StructType\TripsAndPcounter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripsAndPcounter value
     * @throws \InvalidArgumentException
     * @param \StructType\TripsAndPcounter[] $tripsAndPcounter
     * @return \ArrayType\ArrayOfTripsAndPcounter
     */
    public function setTripsAndPcounter(array $tripsAndPcounter = array())
    {
        // validation for constraint: array
        if ('' !== ($tripsAndPcounterArrayErrorMessage = self::validateTripsAndPcounterForArrayConstraintsFromSetTripsAndPcounter($tripsAndPcounter))) {
            throw new \InvalidArgumentException($tripsAndPcounterArrayErrorMessage, __LINE__);
        }
        $this->TripsAndPcounter = $tripsAndPcounter;
        return $this;
    }
    /**
     * Add item to TripsAndPcounter value
     * @throws \InvalidArgumentException
     * @param \StructType\TripsAndPcounter $item
     * @return \ArrayType\ArrayOfTripsAndPcounter
     */
    public function addToTripsAndPcounter(\StructType\TripsAndPcounter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripsAndPcounter) {
            throw new \InvalidArgumentException(sprintf('The TripsAndPcounter property can only contain items of type \StructType\TripsAndPcounter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripsAndPcounter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripsAndPcounter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripsAndPcounter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripsAndPcounter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripsAndPcounter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripsAndPcounter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripsAndPcounter
     */
    public function getAttributeName()
    {
        return 'TripsAndPcounter';
    }
}
