<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ADASspnEvent StructType
 * @subpackage Structs
 */
class ADASspnEvent extends AbstractStructBase
{
    /**
     * The speed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $speed;
    /**
     * The placa
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $placa;
    /**
     * The driver
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $driver;
    /**
     * The fecha
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fecha;
    /**
     * The direccion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $direccion;
    /**
     * The spnName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $spnName;
    /**
     * Constructor method for ADASspnEvent
     * @uses ADASspnEvent::setSpeed()
     * @uses ADASspnEvent::setPlaca()
     * @uses ADASspnEvent::setDriver()
     * @uses ADASspnEvent::setFecha()
     * @uses ADASspnEvent::setDireccion()
     * @uses ADASspnEvent::setSpnName()
     * @param int $speed
     * @param string $placa
     * @param string $driver
     * @param string $fecha
     * @param string $direccion
     * @param string $spnName
     */
    public function __construct($speed = null, $placa = null, $driver = null, $fecha = null, $direccion = null, $spnName = null)
    {
        $this
            ->setSpeed($speed)
            ->setPlaca($placa)
            ->setDriver($driver)
            ->setFecha($fecha)
            ->setDireccion($direccion)
            ->setSpnName($spnName);
    }
    /**
     * Get speed value
     * @return int
     */
    public function getSpeed()
    {
        return $this->speed;
    }
    /**
     * Set speed value
     * @param int $speed
     * @return \StructType\ADASspnEvent
     */
    public function setSpeed($speed = null)
    {
        // validation for constraint: int
        if (!is_null($speed) && !(is_int($speed) || ctype_digit($speed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($speed, true), gettype($speed)), __LINE__);
        }
        $this->speed = $speed;
        return $this;
    }
    /**
     * Get placa value
     * @return string|null
     */
    public function getPlaca()
    {
        return $this->placa;
    }
    /**
     * Set placa value
     * @param string $placa
     * @return \StructType\ADASspnEvent
     */
    public function setPlaca($placa = null)
    {
        // validation for constraint: string
        if (!is_null($placa) && !is_string($placa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($placa, true), gettype($placa)), __LINE__);
        }
        $this->placa = $placa;
        return $this;
    }
    /**
     * Get driver value
     * @return string|null
     */
    public function getDriver()
    {
        return $this->driver;
    }
    /**
     * Set driver value
     * @param string $driver
     * @return \StructType\ADASspnEvent
     */
    public function setDriver($driver = null)
    {
        // validation for constraint: string
        if (!is_null($driver) && !is_string($driver)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driver, true), gettype($driver)), __LINE__);
        }
        $this->driver = $driver;
        return $this;
    }
    /**
     * Get fecha value
     * @return string|null
     */
    public function getFecha()
    {
        return $this->fecha;
    }
    /**
     * Set fecha value
     * @param string $fecha
     * @return \StructType\ADASspnEvent
     */
    public function setFecha($fecha = null)
    {
        // validation for constraint: string
        if (!is_null($fecha) && !is_string($fecha)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fecha, true), gettype($fecha)), __LINE__);
        }
        $this->fecha = $fecha;
        return $this;
    }
    /**
     * Get direccion value
     * @return string|null
     */
    public function getDireccion()
    {
        return $this->direccion;
    }
    /**
     * Set direccion value
     * @param string $direccion
     * @return \StructType\ADASspnEvent
     */
    public function setDireccion($direccion = null)
    {
        // validation for constraint: string
        if (!is_null($direccion) && !is_string($direccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($direccion, true), gettype($direccion)), __LINE__);
        }
        $this->direccion = $direccion;
        return $this;
    }
    /**
     * Get spnName value
     * @return string|null
     */
    public function getSpnName()
    {
        return $this->spnName;
    }
    /**
     * Set spnName value
     * @param string $spnName
     * @return \StructType\ADASspnEvent
     */
    public function setSpnName($spnName = null)
    {
        // validation for constraint: string
        if (!is_null($spnName) && !is_string($spnName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($spnName, true), gettype($spnName)), __LINE__);
        }
        $this->spnName = $spnName;
        return $this;
    }
}
